/*
 * Copyright (C) 2005-2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.imode;

import java.io.IOException;

import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.sourceforge.livez.IllegalRequestException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * }Cj[o^/폜 IP o^/폜̊NX񋟂܂B
 * 
 * @author V _
 */
public abstract class AbstractMyMenuAction {

	/**
	 * ʃOCX^Xł
	 */
	protected static final Log log = LogFactory.getLog(AbstractMyMenuAction.class);

	/**
	 * }Cj[o^܂͍폜Ăяo܂B
	 * 
	 * @param request HTTP NGXg
	 * @param response HTTP X|X
	 * @throws Exception
	 */
	public final void execute(
		final HttpServletRequest request,
		final HttpServletResponse response)
		throws Exception {

		// POST ȊOł̌Ăяoi[hGW̌ďoł͂Ȃƍl
		if (!"POST".equalsIgnoreCase(request.getMethod()))
			throw new IllegalRequestException(request.getMethod());

		final String action = request.getParameter("act");
		MyMenuRequest req = new MyMenuRequestImpl(request);

		boolean success = false;
		if ("reg".equals(action)) {
			try {
				success = register(req);
			} catch (Exception e) {
				if (log.isErrorEnabled())
					log.error(e.getMessage(), e);
			}
		} else if ("rel".equals(action)) {
			try {
				success = release(req);
			} catch (Exception e) {
				if (log.isErrorEnabled())
					log.error(e.getMessage(), e);
			}
		} else
			throw new IllegalRequestException(action);

		write(response, success);
	}

	private static void write(final ServletResponse response, final boolean success) throws IOException {
		response.setContentType("text/html");
		response.setContentLength(3);
		response.getWriter().print(success ? "OK\n" : "NG\n");
	}

	/**
	 * o^sAʂԂ܂B<p>
	 * ꍇ <code>true</code> Ԃ܂BȊȌꍇ́A<code>false</code> Ԃ܂B
	 * 
	 * @param request }Cj[NGXg
	 * @return ́A<code>true</code>BȊȌꍇ́A<code>false</code>
	 * @throws Exception
	 */
	protected abstract boolean register(MyMenuRequest request) throws Exception;

	/**
	 * 폜sAʂԂ܂B<p>
	 * ꍇ <code>true</code> Ԃ܂BȊȌꍇ́A<code>false</code> Ԃ܂B
	 * 
	 * @param request }Cj[NGXg
	 * @return ́A<code>true</code>BȊȌꍇ́A<code>false</code>
	 * @throws Exception
	 */
	protected abstract boolean release(MyMenuRequest request) throws Exception;

}
